import { EIP1474Methods, EIP1193Provider, EIP1193RequestFn, Transport } from 'viem';
import { EventEmitter } from 'eventemitter3';
import { Chain } from 'wagmi/chains';
import CapsuleWeb, { CapsuleModalProps } from '@usecapsule/react-sdk';
export type CapsuleModalPropsForInit = Omit<CapsuleModalProps, 'isOpen' | 'capsule'>;
interface CapsuleEIP1193ProviderOpts extends Partial<CapsuleModalPropsForInit> {
    capsule: CapsuleWeb;
    chainId: string;
    chains: Chain[];
    disableModal?: boolean;
    storageOverride?: Pick<Storage, 'setItem' | 'getItem'>;
    transports?: Record<number, Transport>;
}
export declare class CapsuleEIP1193Provider extends EventEmitter implements EIP1193Provider {
    private currentHexChainId;
    private walletClient;
    private chainTransportSubscribe?;
    private chains;
    private viemChains;
    private capsule;
    private disableModal;
    private storage;
    private modalProps;
    private isModalClosed;
    private transports?;
    constructor(opts: CapsuleEIP1193ProviderOpts);
    private get accounts();
    private getStorageChainId;
    private setChainId;
    private getRpcUrlsFromViemChain;
    private wagmiChainToAddEthereumChainParameters;
    private wagmiChainsToAddEthereumChainParameters;
    private accountFromAddress;
    private setCurrentChain;
    closeModal: () => void;
    request: EIP1193RequestFn<EIP1474Methods>;
}
export {};
