var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx } from "react/jsx-runtime";
import { CapsuleModal } from '@usecapsule/react-sdk';
export function renderModal(capsule, modalProps, onCloseArg) {
    const existingContainer = document.getElementById('capsule-modal');
    const container = existingContainer !== null && existingContainer !== void 0 ? existingContainer : document.createElement('div');
    container.id = 'capsule-modal';
    if (!existingContainer) {
        document.body.appendChild(container); // Add the container to the DOM
    }
    const onClose = () => {
        onCloseArg();
        modalProps.onClose && modalProps.onClose();
        render(false);
    };
    const render = (isOpen) => __awaiter(this, void 0, void 0, function* () {
        const Modal = _jsx(CapsuleModal, Object.assign({}, modalProps, { onClose: onClose, capsule: capsule, isOpen: isOpen }));
        try {
            const client = yield import('react-dom/client');
            const root = client.createRoot(container);
            root.render(Modal);
        }
        catch (e) {
            const ReactDOM = yield import('react-dom');
            ReactDOM.render(Modal, container);
        }
    });
    render(true);
}
